const { dialogflow, SimpleResponse,BasicCard, Carousel, BrowseCarousel, BrowseCarouselItem, Image, Item, List } = require('actions-on-google');
const request = require('sync-request');


const base_url = 'https://api.colorado.ifro.edu.br/academico';


exports.get = (conv) => {

    let params = conv.parameters;

    //Selecionando o curso
    var req = request('GET', `${base_url}/unidade/4/cursos`, {
        headers: {
            Authorization: 'key=Bi479DxWjsNFFcZOVyySbx2vZ7rhhdU4Gr8OeJ0W1qvE7hGHxsQlwhbUZVRttmsQ'
        }
    });
    
    const cursos = JSON.parse(req.getBody('utf8')).cursos;
    let curso = cursos.filter(c => c.nome.toLowerCase().includes(params.curso));
    curso = curso[0];

    //Selecionando a turma
    req = request('GET', `${base_url}/curso/${curso.cursoId}/turmas/abertas`, {
        headers: {
            Authorization: 'key=Bi479DxWjsNFFcZOVyySbx2vZ7rhhdU4Gr8OeJ0W1qvE7hGHxsQlwhbUZVRttmsQ'
        }
    });

    const turmas = JSON.parse(req.getBody('utf8')).turmas;
    console.log(`Turmas` +  JSON.stringify(turmas));
    let turma = turmas.filter(t => 
        t.identificador.includes(params.ano + params.turma.toUpperCase()));
    turma = turma[0];


    //Buscando os horários
    req = request('GET', `${base_url}/turma/${turma.turmaId}/horarios`, {
        headers: {
            Authorization: 'key=Bi479DxWjsNFFcZOVyySbx2vZ7rhhdU4Gr8OeJ0W1qvE7hGHxsQlwhbUZVRttmsQ'
        }
    });
    
    const horarios = JSON.parse(req.getBody('utf8')).horarios;
    let horario = horarios[0];
    
    let text = `Dia **${horario.dataHorario}**, *${horario.diaSemana}*:  \n`;
    let speech = "Encontrei essas aulas: ";
    horario.aulas.forEach(a => {
        var naula = a.nomeClasse.substring(a.nomeClasse.indexOf("-") +1, a.nomeClasse.length );
        text = text.concat(`__${naula}__, às *${a.horarioInicio}*;  \n`);
        speech = speech.concat(`às ${a.horarioInicio}, aula de ${naula}. `);
    });


    conv.ask(new SimpleResponse({
        speech: speech,
        text: 'aqui está:'
    }));

    conv.ask(new BasicCard({
        text: text, // Note the two spaces before '\n' required for
                                        // a line break to be rendered in the card.
        subtitle: `${curso.nome}`,
        title: `horário de ${horario.dataHorario} `,
        display: 'CROPPED',
        //speech: speech,
    }));
}